'use client';

import React, {
    forwardRef,
    useEffect,
    useImperativeHandle,
    useRef,
} from 'react';
import { CheckboxLayoutProps } from './checkbox-layout.types';

export const CheckBoxLayout = forwardRef(function CheckBoxBase(
    { indeterminate, typeInput, type, ...props }: CheckboxLayoutProps,
    ref,
): JSX.Element {
    const checkboxRef = useRef<any>(null);

    useEffect(() => {
        checkboxRef.current.indeterminate = indeterminate === true;
    }, []);

    useImperativeHandle(ref, () => checkboxRef.current);

    const classesType = typeInput || type;

    const classes =
        props.className !== undefined
            ? `m3 m3-${type} ${props.className}`
            : `m3 m3-${classesType}`;

    return (
        <input
            ref={checkboxRef}
            {...props}
            className={classes.trimEnd()}
            type={type}
        />
    );
});
