import React from 'react';
import { IRippleProps } from '../ripple/ripple.types';

export type StateToggleIconType = {
    state: string;
    icon: string;
};

export type ToggleButtonType = {
    selected: string;
    unselected: string;
};

export interface IconButtonMainProps
    extends React.ButtonHTMLAttributes<HTMLButtonElement> {
    icon: string;
    toggled?: false | ToggleButtonType;
    disabled?: boolean;
    variant?: 'default' | 'filled' | 'tonal' | 'outlined';
}

export interface IconButtonProps extends IconButtonMainProps, IRippleProps {}
